require "oauth2"
require "colorize"

# The main WTC driver
module WTC_
	# IntraToken Class
	#
	# Example:
	#   >> tokenizer = WTC_::IntraToken.new(
	# uid,
	# secret,
	# scope
	# debug )
	# token = tokenizer.Get_Token()
	
	# Arguments:
	#   UID: (String)
	#   SECRET: (String)
	#   SCOPE: (String)
	#   DEBUG: (Boolean)
	class IntraToken
		@@token = nil
	
		@@uid
		@@secret
		@@debug
		@@scope
	

		def initialize(uid, secret, scope, debug=false)
			# Get_Token()
			@uid	= uid
			@scope	= scope
			@secret	= secret
			@debug	= debug
		end
		
		def Get_Token()
			puts "Getting user token".red
			client	= OAuth2::Client.new(@uid, @secret, site: "https://api.intra.42.fr")
			@token	= client.client_credentials.get_token(scope: @scope)
			puts "Token received".green
			if @debug == true
				puts "Your acces Token:: %<token>s".green % [token:@token.token]
			end
			return (@token)
		end
	
	end
end